import 'package:taskflow/taskflow.dart';

main(List<String> args) {
  var simpleTask = Task((context) async {
    await Future.delayed(Duration(seconds: 1));
    print('Simple task executed.');
    return TaskResult(null);
  });

  simpleTask(TaskFlowContext());

  var conditionalTask = Task.when(
    () async => true,
    (context) async {
      print('Conditional task executed.');
      return TaskResult(null);
    },
  );

  conditionalTask(TaskFlowContext());

  var parallelTask = ParallelTask([
    simpleTask,
    conditionalTask,
  ]);
  parallelTask(TaskFlowContext());
}
